Ball ball = new Ball();
Racket racket = new Racket();

Timer = Draw;

void Draw()
{
	Background(128);
	NoStroke();
	Fill(228);

	ball.Draw();
	ball.Move();
	racket.Draw();
	racket.Move();
	racket.HitBall(ball);
}

class Ball
{
    double x = 0;
    double y = Random(0, Height); 
    double speedX = 2;
    double speedY = 2; 
        
    public void Draw() 
    {
    	Circle(x, y, 50);
    }
    
    public void Move()
    { 
 		x = x + speedX;
		y = y + speedY;
		
		if(y > Height || y < 0)				// upper/lower edge
	        speedY = speedY * -1;   
    }
        
    public void Start()
    {
    	x = 0; 
    	y = Random(0, Height);
    	speedX = 2;
    	speedY = 2;
    }
    
    public void IncreaseSpeed()
    {
    	speedX = speedX * -1;	

	    if(speedX < 0)
        	speedX--;
        else
        	speedX++;
    }
    public double GetX()
    {
    	return x;
    }
    public double GetY()
    {
    	return y;
    }
}

class Racket
{
	double cxRacket = 20;
	double cyRacket = 150;
	double xRacket;

	public void Draw()
	{
		Rect(xRacket, MouseY, cxRacket, cyRacket);
	}
	
	public void Move()
	{
		xRacket = Width - (cxRacket / 2);
	}
	
	public void HitBall(Ball ball)
	{
		double yRacketTop    = MouseY - (cyRacket / 2);
		double yRacketBottom = MouseY + (cyRacket / 2);
		bool   hitRacket = ball.GetY() >= yRacketTop && 
		                   ball.GetY() <= yRacketBottom;
		                   		
		// right edge && right racket || left wall
		if((ball.GetX() > Width && hitRacket == true) || ball.GetX() < 0)
		{
			if(cyRacket > 100)
				cyRacket = cyRacket - 3;
	        
	        ball.IncreaseSpeed();
		}
		
	    if(ball.GetX() > Width && hitRacket == false)	// Ball not hit
	    {
	    	ball.Start();
	    	cyRacket = 150;
	    }
	}
}
